/*
 * adc_deal.c
 *
 *  Created on: 2014-12-9
 *      Author: Administrator
 */
#include "System.h"
#include "drvflash.h"
#include "stdlib.h"
#include "math.h"
#include "my define.h"
#include "adc_deal.h"
#include "Display.h"

/******************************************************************************
 * name   :adc_smooth_filter()
 * input  :ADC value
 * output :
 * date   :
 * note   :
 * modify :
 ********************************************************************************/
void adc_smooth_filter(void)
{
	unsigned char i=0;
	int adc_sum=0;

	if(ad_bok==1)  //check ADC convert is ok
	{
		sys_flag0=sys_flag0^0x02;  //clear ADC convert finish flag
		ADOK=1; 					//ADɱ־   0ADδɣ  1
		ad_bok=0;

		temp=adc_avg-adc_value;
		adsign=0;
		if(temp<0)
			adsign=1;  				//tempű־

		temp=abs(temp);
		if(temp<(Tracezero*3))				//temp0x400Ա
		{
			adc_sum=0;
			for(i=0;i<avg_num;i++)				//average
			{
				adc_sum=adc_sum+adc_buf[i];
			}
			adc_avg=adc_sum/avg_num;
			for(i=avg_num-1;i>0;i--)
			{
				adc_buf[i]=adc_buf[i-1];  		//update adc_buf data
			}
			adc_buf[0]=adc_value;
			def_num=0;
		}

		else									//temp-400>=0
		{
			if((adsign==adsignb)&&(def_num>=2))
			{
				def_num=0;
				adc_avg=adc_value;
				for(i=0;i<avg_num;i++)
				{
					adc_buf[i]=adc_value;   		//update adc_buf data
					adc_avg_buffer[i]=adc_value;
				}
			}
			else
			{
				adsignb=0;
				if(adsign==1)
				{
					adsignb=1;
				}
				def_num++;
			}
		}
//=====================================
	    adcout=adc_avg;
	    adcout=adcout>>(24-adc_enob);  			//get ENOB
        temp=abs(adcout-adstable);				//ȵĲֵ

		if(temp<Tracezero*2)
		{
			if(adstbcnt!=0)
			{
				adstbcnt--;
			}
			if(adstbcnt==0)
			{
				adstbok=1;				//ADȶ־
				adcout=adcout>>2;
				adstable=adstable>>2;
				adcout=adcout+adstable*3;
			}
		}
		else
		{
			adstbcnt=8;
			adstbok=0;
		}
		adstable=adcout;

	}
}
/****************************************************************************
 * name    : calculate_wg()
 * func    : calculate the act weight
 * input   : no
 * output  : no
 * date    : 2014-12-11
 * note    : resolution:ʾı仯Сλ̶ȣ2dʾÿ2gһ
 * modify  :
 ****************************************************************************/
void calculate_wg(void)
{
   int adc_change=0;

   if(cal_flag==0&&sys_flag0&0x08)        //under the measure weight mode
  {
	  int temp1=0;						//׷0
	 // zerobuf=adc_zero;
	  temp1=adcout-adc_zero;			//׷
      if(abs(temp1)<Tracezero)
      {
    	  if((adstbok==1)&&(adsum>10))			//ȺADΪ10
    	  {
    		  temp1=abs(zerobuf)+Tracezero*3;			//zerobuf+1.5*Traceweight
    		  if(temp1>abs(adstable))
    		  {
    			  adc_zero=adstable;
    		  }
    		  temp1=0;
        	  adsum=0;
    	  }
      }

 /*     if(adstbok==1)	  	  	  	  	  	  //׷
      {
         int temp2=0;				//׷ر
    	  temp2=adstable-TraceADCbuf;
    	  if(abs(temp2)<Tracezero)
    	  {
    		  cal_zero_adc=cal_zero_adc+temp2;
    	  }
    	  TraceADCbuf=adstable;
      }
*/
	   adc_change=adstable-adc_zero;
/*      if(adc_change<0)
      {
    	  sys_flag0=sys_flag0|0x20;
    	  adc_change=~adc_change;
      }
      else
      {
    	  sys_flag0=sys_flag0&0xdf;
      }
*/
      weight=(float)stander_wg*adc_change;
      weight=weight/cal_stander_adc;
     // if(abs(weight)>resolution)
   /*      	  if(abs(weight)<resolution)     //auto zero
         {
             zero_num++;
             if(zero_num>=4)  //update the zero adc value
               {
                  zero_num=0;
                  cal_zero_adc=adcout;
                  weight=0;
               }
         }
         else
        	 time_counter=0;  //clear time counter in case have weight;
*/
      if(adstbok==1)
      {
          if(sys_flag0&0x04)               //hander tare/zero
          {
        	  sys_flag0=sys_flag0^0x04;  	// clear tare/zero flag
        	  tare_wg=weight;
        	  //sys_flag0=sys_flag0^0x10;
          }
      }
      weight=weight-tare_wg;

/*         if(sys_flag0&0x04)               //hander tare/zero
         {
           //  tare_wg=0;
        	 if(weight*10<full_range)  //face to zero
             {
            	 sys_flag0=sys_flag0^0x04;  // clear tare/zero flag
            	 adc_zero=adcout;
            	 weight=0;
             }
             else if(weight*10>full_range) //tare
             {
            	 sys_flag0=sys_flag0^0x04;  // clear tare/zero flag
            	 tare_wg=weight;
            	 sys_flag0=sys_flag0^0x10;
             }

         }
         if(sys_flag0&0x10)    //if under tare mode
         {
        	 weight=weight-tare_wg;
         }	*/

         switch(decimal_piont)
         {
    	 float wg_temp=0;
    	 float cal_temp=0;
    	 int weightbuf1;
    	 int weightbuf2;
         case 0:      					//input 
         {
        	 if(resolution/10<1)
        	 {
        		 wg_temp=weight*100;
        		 weightbuf1=(int)wg_temp%100;				//õС2λ
        		 weightbuf2=weightbuf1/((int)resolution*10);		//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution*10);		//weightbuf1=ԽȺ
        		 wg_temp=(int)weight;						//wg_temp=weight
        		 if(abs(weightbuf1)>=((int)resolution*5))				//С1/2resolutionʱ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempС
        		 if(cal_temp==1)						//Сλ
        		 {
        			 wg_temp=wg_temp+1;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;
        	/*	 wg_temp=weight*10;
        		 cal_temp=(int)(wg_temp)%10;
            	 if(cal_temp>7)   //
            		 weight=weight+1;   //λ
        		 wg_temp=weight/((float)resolution/10);
        		 weight=wg_temp*((float)resolution/10);  */
        	 }
        	 else
        	 {
        		 wg_temp=weight*10;
        		 weightbuf1=(int)wg_temp%100;				//õС1λ
        		 weightbuf2=weightbuf1/((int)resolution);			//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution);			//weightbuf1=ԽȺ
        		 wg_temp=(int)wg_temp/100;					//wg_temp=weight(λ)
        		 wg_temp=(int)wg_temp*10;
        		 if(abs(weightbuf1)>=(resolution/2))				//С1/2resolutionʱ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempǸ
        		 if(cal_temp==10)							//λʮλ
        		 {
        			 wg_temp=wg_temp+10;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;
        		/* wg_temp=weight*10;
        		 cal_temp=(int)(wg_temp)%10;
            	 if(cal_temp>7)   //
            		 weight=weight+1; //λ
        		 cal_temp=cal_temp/10;
         	     wg_temp=weight*(resolution/10);
        	     wg_temp=wg_temp/(resolution/10);
                 weight=(wg_temp+cal_temp);   */
        	 }

        	 break;
         }
         case 1: {   //0.1g               //ʺresolution <1g;   ȴﵽ0.1g
        	 if(resolution/10<1)
        	 {
        		 wg_temp=weight*100;
        		 weightbuf1=(int)wg_temp%100;				//õС2λ
        		 weightbuf2=weightbuf1/((int)resolution*10);		//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution*10);		//weightbuf1=ԽȺ
        		 wg_temp=(int)weight;						//wg_temp=weight
        		 if(abs(weightbuf1)>=((int)resolution*5))				//С1/2resolutionʱ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempС
        		 if(cal_temp==1)						//Сλ
        		 {
        			 wg_temp=wg_temp+1;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight*100;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;
        	/*	 wg_temp=weight*100;
        		 cal_temp=(int)(wg_temp)%10;
        		 if(cal_temp>7)
        			 weight=weight+0.1;//λ
        		 cal_temp=cal_temp/100;
        		 wg_temp=weight/((float)resolution/10);
        		 weight=wg_temp*((float)resolution/10);
        		 weight=(weight+cal_temp)*100;  */
        	 }
        	 else
        	 {
        		 wg_temp=weight*10;
        		 weightbuf1=(int)wg_temp%100;				//õС1λ
        		 weightbuf2=weightbuf1/((int)resolution);			//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution);			//weightbuf1=ԽȺ
        		 wg_temp=(int)wg_temp/100;					//wg_temp=weight(λ)
        		 wg_temp=(int)wg_temp*10;
        		 if(abs(weightbuf1)>=(resolution/2))				//С1/2resolutionʱ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempǸ
        		 if(cal_temp==10)							//λʮλ
        		 {
        			 wg_temp=wg_temp+10;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight*100;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;

        		 /* wg_temp=weight*100;
        		 cal_temp=(int)(wg_temp)%10;
        		 cal_temp=cal_temp/100;
        		 wg_temp=(int)wg_temp%10;
        		 if(wg_temp>7)
        			 weight=weight+0.1;
         	     wg_temp=weight*(resolution/10);
        	     wg_temp=wg_temp/(resolution/10);
                 weight=(wg_temp+cal_temp)*100;  */
        	 }
        	 break;
         }
         case 2:   //0.01kg   Ҫresolution >= 10g   ȴﵽ10g
         {
        	 if(resolution/10<1)
        	 {
        		 wg_temp=weight*100;
        		 weightbuf1=(int)wg_temp%100;				//õС2λ
        		 weightbuf2=weightbuf1/((int)resolution*10);		//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution*10);		//weightbuf1=ԽȺ
        		 wg_temp=(int)weight;						//wg_temp=weight
        		 if(abs(weightbuf1)>=((int)resolution*5))				//С1/2resolutionʱ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempС
        		 if(cal_temp==1)						//Сλ
        		 {
        			 wg_temp=wg_temp+1;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;
        		 //wg_temp=weight*100;
        		 //cal_temp=wg_temp%10;
        		 //cal_temp=cal_temp/100;
        		 //wg_temp=weight/((float)resolution/10);
        		 //weight=wg_temp*((float)resolution/10);
        		  //weight=weight;
        	 }
        	 else
        	 {
        		 wg_temp=weight*10;
        		 weightbuf1=(int)wg_temp%100;				//õС1λ
        		 weightbuf2=weightbuf1/((int)resolution);			//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution);			//weightbuf1=ԽȺ
        		 wg_temp=(int)wg_temp/100;					//wg_temp=weight(λ)
        		 wg_temp=(int)wg_temp*10;
        		 if(abs(weightbuf1)>=(resolution/2))				//С1/2*resolutionʱλ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempǸ
        		 if(cal_temp==10)							//λʮλ
        		 {
        			 wg_temp=wg_temp+10;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;
        	/*	 wg_temp=weight;
        		 cal_temp=(int)(wg_temp)%10;
            	 if(wg_temp>7)
            		 weight=weight+10;   //λKG;ȡС2λ׼ȷֵ׼ȷ1g0.1gֵ
        		 //cal_temp=cal_temp/10;
         	     wg_temp=weight*(resolution/10);
        	     wg_temp=wg_temp/(resolution/10);
                 weight=(wg_temp+cal_temp);  */
        	 }


        	/* wg_temp=weight*10/resolution;
        	 cal_temp=wg_temp/(full_range/resolution);
        	 weight=cal_temp*full_range;
        	 weight=weight;//*/
        	 break;
         }
         case 3:  //0.001kg         //ʺ1g < resolution < 10g ȴﵽ1g
         {
        	 if(resolution/10<1)
        	 {
        		 wg_temp=weight*100;
        		 weightbuf1=(int)wg_temp%100;				//õС2λ
        		 weightbuf2=weightbuf1/((int)resolution*10);		//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution*10);		//weightbuf1=ԽȺ
        		 wg_temp=(int)weight;						//wg_temp=weight
        		 if(abs(weightbuf1)>=((int)resolution*5))				//С1/2resolutionʱ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempС
        		 if(cal_temp==1)						//Сλ
        		 {
        			 wg_temp=wg_temp+1;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight*10;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;
        		 //wg_temp=weight/((float)resolution/10);
        		 //wg_temp=(int)wg_temp*((float)resolution/10);			//wg_tempõweight
        		  //weight=wg_temp*10;
        	 }
        	 else
        	 {
        		 wg_temp=weight*10;
        		 weightbuf1=(int)wg_temp%100;				//õС1λ
        		 weightbuf2=weightbuf1/((int)resolution);			//weightbuf2=ȵı
        		 weightbuf1=weightbuf1%((int)resolution);			//weightbuf1=ԽȺ
        		 wg_temp=(int)wg_temp/100;					//wg_temp=weight(λ)
        		 wg_temp=(int)wg_temp*10;
        		 if(abs(weightbuf1)>=(resolution/2))				//С1/2resolutionʱ
        		 {
        			 weightbuf2++;
        		 }
        		 cal_temp=((float)weightbuf2*(float)resolution)/10;		//cal_tempǸ
        		 if(cal_temp==10)							//λʮλ
        		 {
        			 wg_temp=wg_temp+10;
        			 cal_temp=0;
        		 }
        		 weight=wg_temp+cal_temp;
        		 disweight=weight*10;
        		 if(weight<2.7)						//жϣweight<3gʱʾ0
        			 disweight=0;
        	      else
        	    	 time_counter=0;
        		 /*wg_temp=weight*10;
        		 cal_temp=(int)(wg_temp)%10;
        		 if(cal_temp>7)
        			 weight=weight+1;   			//λKG;ȡС3λ׼ȷֵ׼ȷ1g0.1gֵ
        		 cal_temp=cal_temp/10;
         	     wg_temp=weight*(resolution/10);
        	     wg_temp=wg_temp/(resolution/10);
                 weight=(wg_temp+cal_temp)*10;
                 asm("nop"); */
        	 }

        	 /*wg_temp=weight*10/resolution;
        	 cal_temp=full_range/resolution;
        	 cal_temp=wg_temp/cal_temp;
        	 weight=cal_temp*full_range;
        	 weight=weight;
        	 wg_temp=(int)weight%10;
        	 if(wg_temp>7)
        		 weight=weight+10;   //λKG;ȡС3λ׼ȷֵ׼ȷ1g0.1gֵ*/

        	 break;
         }
         default:
        	 break;
         }
  	  }
}

void adc_calibrate(void)
{
	int i=0;
	time_counter=0;  					//clear the time counter all the away under calibration mode;
	if(TraceWeight==0)
	{
		TraceWeight=4;
	}
	adc_smooth_filter();
	if(cal_flag&0x80)  					//under calibration mode;
	{
	//	adc_smooth_filter();
		while(ADOK==0)
			adc_smooth_filter();
		ADOK=0;
		adsign=0;

		if(cal_flag&0x20)  				//under the zero weight calibration mode ;
		{
			adstbcnt=8;
			adstbok=0;
			while(adstbok==0)
			{
				adc_smooth_filter();
				//Delay(10000);
				LCD_ADC_Display(adcout);
				while(i<30000)
				{
					i++;
				}
				i=0;
			}
			cal_zero_adc=adstable;				//õADֵ
			cal_flag=cal_flag^0x80;  			//clear the 'zero calibration flag'
			cal_flag=0x7f&(cal_flag<<1);   		//auto into the stander weight calibration mode ;
			adstbok=0;
			adstbcnt=8;
		}

		else if(cal_flag&0x40) 					//under the stander weight calibration mode ;
		{
			adstbcnt=8;
			adstbok=0;
			while(adstbok==0)
			{
				adc_smooth_filter();
				//Delay(10000);
				LCD_ADC_Display(adcout);
				cal_stander_adc=adstable-cal_zero_adc;  	//õstander ADֵ
				temp=cal_stander_adc-stander_wg;
				if(temp/2<=0)
				{
					adstbcnt=8;
					adstbok=0;
				}
				while(i<30000)
				{
					i++;
				}
				i=0;
			}
			adstbok=0;
			adstbcnt=8;
			cal_flag=0; 							 //clear the 'stander weight calibration flag'

			SYS_DisableGIE();
			cal_summer++;
			//save the calibration times
			DrvFlash_Burn_Word(save_addr,0x8000,cal_summer);
            cal_summer=ReadWord(save_addr);
			//save the calibration value to flash
            unsigned int flash_temp;
            //save the 'resolution'С̶ֵ
            flash_temp=resolution;
            DrvFlash_Burn_Word(save_addr+0x04,0x8000,flash_temp);
            //save the 'adc_enob'
            flash_temp=adc_enob;
            DrvFlash_Burn_Word(save_addr+0x8,0x8000,flash_temp);
            //save the 'decimal_piont'Сλã
            flash_temp=decimal_piont;
            DrvFlash_Burn_Word(save_addr+0xc,0x8000,flash_temp);
            //save the 'full_range'  full scale
            DrvFlash_Burn_Word(save_addr+0x10,0x8000,full_range);
            //save the "stander_wg' calibration weight;
            DrvFlash_Burn_Word(save_addr+0x14,0x8000,stander_wg);
            //save the 'cal_stander_adc'
            //cal_stander_adc=abs(cal_stander_adc-cal_zero_adc);
            DrvFlash_Burn_Word(save_addr+0x18,0x8000,cal_stander_adc);
            DrvFlash_Burn_Word(save_addr+0x1c,0x8000,cal_zero_adc);

            SYS_EnableGIE(0X7,0X1FF);
            Displaycal_ok(); 			//ʾ9~1
		}
	}
}



